import json
import os,sys
import struct
import unicodedata
from PIL import Image, ImageEnhance
import numpy as np
from PIL import Image, ImageDraw, ImageFont, GifImagePlugin


"""
void ToRGB(int Hexa, int *R, int *G, int *B) {
        *R = (((Hexa >> 11) & 0b11111) << 3);
        *G = (((Hexa >> 5) & 0b111111) << 2);
        *B = ((Hexa & 0b11111) << 3);
    };
"""

def ConvertRGB(RGB):
    R = RGB[0]
    G = RGB[1]
    B = RGB[2]
    return ((R >> 3) << 11) + ((G >> 2) << 5) + (B >> 3)

def ConvertRGB(RGB):
    #make grey scale
    R = RGB[0]
    G = RGB[1]
    B = RGB[2]
    grey = (R + G + B) // 3
    return grey

def SaveString(fp,string):
    for i in string:
        fp.write(struct.pack('>B', i))

SizeScreen = (396,224)

#make function import all images from a folder and save array of pixels in list
def import_images_from_folder(folder):
    images = []
    width, height = 0, 0
    lst = os.listdir(folder)
    #sort the list 0.png, 1.png, 2.png, ...
    lst.sort(key=lambda f: int(''.join(filter(str.isdigit, f))))
    for filename in lst:
        print(filename)
        img = Image.open(os.path.join(folder,filename))
        #convert as greyscale
        img = img.convert("L")
        #convert to RGBA
        #img = img.convert("RGBA")
        #change Brightness
        img = ImageEnhance.Brightness(img).enhance(1.5)
        #resize image with max size of 396x224
        if img.size[0] > img.size[1]:
            new_width = 396
            new_height = int((new_width * img.size[1]) / img.size[0])
        else:
            new_height = 224
            new_width = int((new_height * img.size[0]) / img.size[1])
        new_width, new_height = new_width//2, new_height//2
        width, height = new_width, new_height
        img = img.resize((new_width, new_height))
        if img is not None:
            arr = np.array(img)
            #convert to RGB
            txt = []
            #for i in range(len(arr)):
            #    for j in range(len(arr[i])):
            #        txt += [ConvertRGB(arr[i][j])]
            #convert to grey scale
            for i in range(len(arr)):
                for j in range(len(arr[i])):
                    txt += [arr[i][j]]
            images.append(txt)
    return images, (width, height)

#make function to convert to binary
def ConvertToBinary(filename,lst,size):
    with open(filename, 'wb') as f:
        #write size of screen
        f.write(struct.pack('>i', size[0]))
        f.write(struct.pack('>i', size[1]))
        #write number of frames
        f.write(struct.pack('>i', len(lst)))
        #write name of file
        f.write(struct.pack('>i', len(filename)))
        f.write(b''.join(struct.pack('>b', n) for n in str.encode(filename)))
        for image in lst:
            SaveString(f,image)


def ConvertGid(filenameGif,filenameBin):
    img = Image.open(filenameGif)
    #remove Temp folder if it exists
    if os.path.exists("Temp"):# and remove all files in folder
        for filename in os.listdir("Temp"):
            os.remove("Temp/" + filename)
        os.rmdir("Temp")
    #create Temp folder
    os.mkdir("Temp")
    #convert gif to frames and save in Temp folder with name 0.png, 1.png, 2.png, etc
    for i in range(img.n_frames):
        img.seek(i)
        #if i%2 == 1:continue
        img.save("Temp/" + str(i) + ".png")
    #import images from Temp folder
    lst,size = import_images_from_folder("Temp")
    #convert to binary
    ConvertToBinary(filenameBin,lst,size)

    
ConvertGid("one-piece.gif","VIDEO.bin")
    